#!/usr/bin/perl -w
#
# renames all ._cfg files found from current directory downwards (with
# prompting)
#
#    Copyright (C) 2004,  Iain Buchanan
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

use strict;
use IO::Handle;

my $diff = '';
if (defined ($ENV{'DIFF'}) && ($ENV{'DIFF'}) ne '') {
   $diff = $ENV{'DIFF'};
}
else {
   $diff='diff';
}
my @files = `find . -name "._cfg0000_*"`;
print "found '", $#files + 1, "' updated config files";

FILE: foreach my $file (@files) {
   chomp $file;
   if ($file =~ /^(.*)._cfg0000_(.*)$/) {
      my $path = $1;
      my $name = $2;

      my $input;
      do {
         $input = '';
         print "\nmove '$file' to '$path$name': (y)es/(n)o/(d)iff?";
         $input .= STDIN->getline;
         chomp $input;
         if ($input =~ /^d$/) {
            my @result = `$diff $path$name $file`;
            print @result;
         }
      } while ($input !~ /^(y|n)$/);

      if ($input =~ /^y$/) {
         &mv_file ("$file", "$path$name");
      }
      else {
         print " leaving $file untouched\n";
      }
   }
   else {
      print "file '$file' doesn't match\n";
   }
}

print "\n";

sub mv_file {
   print "moving...";
   `mv $_[0] $_[1]`;
   print " done\n";
}
